if RequiredScript == "lib/units/enemies/cop/copdamage" then
	local mvec3_dot = mvector3.dot
	local mvec3_norm = mvector3.normalize
	local function _is_blackjack(my_unit, attacker_unit, health)
		local blackjack_data = {}
		local unit_mov = my_unit:movement()
		if unit_mov and unit_mov:cool() then
			local unit_pos = my_unit:position()
			local hit_dir = unit_pos - attacker_unit:position()
			mvec3_norm(hit_dir)
			local from_behind = mvec3_dot(hit_dir, my_unit:rotation():y()) >= 0
			if from_behind then
				local peer_unit = managers.network:session():peer_by_unit(attacker_unit)
				if peer_unit then
					local outfit = peer_unit:blackmarket_outfit()
					if outfit and outfit.melee_weapon then
						local melee_weap = outfit.melee_weapon
						local weap_tweak = tweak_data.blackmarket.melee_weapons[melee_weap]
						if weap_tweak then
							if not weap_tweak.type or weap_tweak.type ~= "knife" then
								local melee_stats = weap_tweak.stats
								if melee_stats and melee_stats.min_damage_effect and melee_stats.min_damage_effect > 1 or weap_tweak.instant then
									local col_ray = { ray = hit_dir, body = my_unit:body("body"), position = unit_pos }
									blackjack_data.attacker_unit = attacker_unit
									blackjack_data.variant = "blackjack"
									blackjack_data.col_ray = col_ray
									blackjack_data.damage = health
									blackjack_data.damage_effect = 1
									blackjack_data.name_id = melee_weap
									blackjack_data.is_blackjack = true
								end
							end
						end
					end
				end
			end
		end
		return blackjack_data
	end
	local old_melee = CopDamage.damage_melee
	function CopDamage:damage_melee(attack_data, ...)
		local attacker_unit = attack_data.attacker_unit
		if attacker_unit then
			local blackjack_data = _is_blackjack(self._unit, attacker_unit, self._HEALTH_INIT)
			if blackjack_data and blackjack_data.is_blackjack then
				attacker_unit:sound():say("f03b_any", true)
				attack_data = blackjack_data
			end
		end
		return old_melee(self, attack_data, ...)
	end
	local old_sync = CopDamage.sync_damage_melee
	function CopDamage:sync_damage_melee(attacker_unit, ...)
		if attacker_unit then
			local blackjack_data = _is_blackjack(self._unit, attacker_unit, self._HEALTH_INIT)
			if blackjack_data and blackjack_data.is_blackjack then
				attacker_unit:sound():say("f03b_any", true)
				return self:damage_melee(blackjack_data)
			end
		end
		return old_sync(self, attacker_unit, ...)
	end
end

if RequiredScript == "lib/units/enemies/cop/copbrain" then
	local is_server = Network:is_server()
	local old_clbk = CopBrain.clbk_death
	function CopBrain:clbk_death(my_unit, damage_info, ...)
		if is_server then
			local variant = damage_info.variant
			if variant and variant == "blackjack" then
				self._unit:unit_data().has_alarm_pager = false
				self._unit:interaction():set_disabled(true)
			end
		end
		return old_clbk(self, my_unit, damage_info, ...)
	end
end

if RequiredScript == "lib/managers/statisticsmanager" then
	local old_anyone = StatisticsManager.killed_by_anyone
	function StatisticsManager:killed_by_anyone(data)
		local variant = data.variant
		if variant and variant == "blackjack" then
			return
		end
		return old_anyone(self, data)
	end
	local old_killed = StatisticsManager.killed
	function StatisticsManager:killed(data)
		local variant = data.variant
		if variant and variant == "blackjack" then
			return
		end
		return old_killed(self, data)
	end
end